
@ECHO off

:: Check for a previous installation
IF EXIST "C:\Program Files\LogDoctor" (
	ECHO Warning: a previous installation exists, please run the 'update' scripts instead
	cd "%actual_path%"
	PAUSE
	EXIT /B 0
)


SET data_path=%USERPROFILE%\AppData\Local\LogDoctor
IF NOT EXIST "%data_path%" mkdir "%data_path%"

IF NOT EXIST "%data_path%\logdoctor.conf" GOTO :step11

:loop1
ECHO:
ECHO Warning: a configuration file already exists
ECHO If you choose 'YES' the current file will be overwritten
ECHO If you choose 'NO' the current file will be kept
SET /P agree=Overwrite? [y/n] :

IF "%agree%"=="y" (
	GOTO :step1
)
IF "%agree%"=="Y" (
	GOTO :step1
)
IF "%agree%"=="n" (
	GOTO :step2
)
IF "%agree%"=="N" (
	GOTO :step2
)
ECHO NOT A VALID ANSWER
GOTO :loop1

:step1

copy /V /Y logdoctor.conf %data_path%\
IF ERRORLEVEL 1 (
	ECHO:
	ECHO Error: failed to copy configuration file
	cd "%actual_path%"
	PAUSE
	EXIT /B 1
)

:step2

xcopy /E /V /Y  logdocdata %data_path%\
IF ERRORLEVEL 1 (
	ECHO:
	ECHO Error: failed to copy LogDoctor's data
	cd "%actual_path%"
	PAUSE
	EXIT /B 1
)


SET exec_path=C:\Program Files\LogDoctor

IF NOT EXIST "%exec_path%" GOTO :step3

rmdir /S /Q "%exec_path%"
IF ERRORLEVEL 1 (
	ECHO:
	ECHO Error: failed to renew the executable directory
	cd "%actual_path%"
	PAUSE
	EXIT /B 1
)

:step3

xcopy /E /I /V /Y LogDoctor "%exec_path%"
IF ERRORLEVEL 1 (
	ECHO:
	ECHO Error: failed to copy the executable
	cd "%actual_path%"
	PAUSE
	EXIT /B 1
)


SET link_path=C:\ProgramData\Microsoft\Windows\Start Menu\Programs\LogDoctor

IF NOT EXIST "%link_path%" GOTO :step4

rmdir /S /Q "%link_path%"
IF ERRORLEVEL 1 (
	ECHO:
	ECHO Error: failed to remove old menu entry
	cd "%actual_path%"
	PAUSE
	EXIT /B 1
)

:step4

mkdir "%link_path%"

SET link_path=%link_path%\LogDoctor.exe

IF NOT EXIST "%link_path%" GOTO :step5

del "%link_path%"
IF ERRORLEVEL 1 (
	ECHO:
	ECHO Error: failed to remove symlink
	cd "%actual_path%"
	PAUSE
	EXIT /B 1
)

:step5

mklink "%link_path%" "%exec_path%\LogDoctor.exe"


copy /V /Y LogDoctor.svg "%exec_path%\LogDoctor.svg"
IF ERRORLEVEL 1 (
	ECHO:
	ECHO Error: failed to copy the icon
	cd "%actual_path%"
	PAUSE
	EXIT /B 1
)


:: Installation finished
ECHO:
ECHO Installation finished
cd "%actual_path%"
PAUSE


